/*
 *  Camera.h
 *  metricspace
 *
 *  Created by Michael Tauraso on 12/17/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include "Tuple.h"

#pragma once

class Camera
{
public:
	

	static Camera * getInstance();

	void setUpVec(Tuple up);
	Tuple getUpVec();
	
	// sets point eye looks at
	void setLookAt(Tuple pos);
	Tuple getLookAt();

	void setAspect(float ratio);
	void setFOV(float deg);
	
	// gets absolute coords of eye
	Tuple getAbsolutePos();
	
	// gets/sets cartesian location of eye wrt 
	// look at point
	void setCartLocation(Tuple pos);
	Tuple getCartLocation();
	
	friend void Reshape(int w, int h);
	
	void Look();

	// gets sets spherical coords wrt
	// look at point.
	// all angles expressed as degrees
	void setSphereLocation(Tuple pos);
	Tuple getSphereLocation();
	
private:
	Camera();
	static Camera * m_instance;
	
	//void updatePos();
	void updateFrust();
	
	//internally all angles are in degrees
	
	//cartesian coords of position to look at
	Tuple m_lookAtPos;
	//cartPos is x,y,z offset from lookAtPos
	Tuple m_cartPos;
	//spherePos is rho,theta,phi offset from lookAtPos
	Tuple m_spherePos;
	
	//up vector, cartesian coordinates;
	Tuple m_up;
	
	float m_neardist;
	float m_fardist;

	float m_aspect;
	float m_fov;
};

