/*
 *  Matrix4.h
 *  metricspace
 *
 *  Created by Michael Tauraso on 12/17/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#if defined(_WIN32)
#	include <GL/glut.h>
#else
#	include <GLUT/glut.h>
#endif

#include "Tuple.h"

#pragma once

class Matrix
{
public:
	Matrix();
	Matrix(Tuple r1,Tuple r2,Tuple r3=Tuple(0,0,0,0),Tuple r4=Tuple(0,0,0,0));
	Matrix(const Matrix& rhs);
	Matrix(std::string filename);
	
	GLfloat * getMat3();
	GLfloat * getMatn(int n);
	
	Tuple & operator [] (int i);
	const Tuple & operator[] (int i) const;
			

	
private:
		
	Tuple m_rows [4];
		
	friend ColumnTuple operator * (const Matrix & lhs, const ColumnTuple & rhs);
	friend RowTuple operator * (const RowTuple & lhs, const Matrix & rhs);
};