/*
 *  Metric.h
 *  metricspace
 *
 *  Created by Michael Tauraso on 12/17/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include <string>

#include <glutwrapper.h>

#include "Tuple.h"
#include "Matrix.h"
#include "Shader.h"

#pragma once

class Metric
{
public:	
	//Metric();
	virtual float distance(Tuple x, Tuple y = Tuple(0,0,0))=0;
	virtual Tuple transform(const Tuple & rhs);
	//virtual void loadVertexProgram()=0;
	
	void Initialize();
	void Apply();
protected:
	virtual void Use(){};
		
	// Program object with main() which uses distance() to 
	// transform vertices
	ShaderProg m_mainProgram;
};

class EuclideanMetric: public Metric
{
public:
	EuclideanMetric();
	virtual float distance(Tuple x, Tuple y= Tuple(0,0,0));
	virtual Tuple transform(const Tuple & rhs);
};

class CityBlockMetric: public Metric
{
public:
	CityBlockMetric();
	virtual float distance(Tuple x, Tuple y= Tuple(0,0,0));
};

class RiemannianMetric: public Metric
{
public:
	RiemannianMetric(Matrix mat);
	RiemannianMetric(std::string filename);


	virtual float distance(Tuple x, Tuple y=Tuple(0,0,0));
	
private:
	void Use();
	
	Matrix m_mat;
	GLint m_matHandle;
};