/*
 *  InputHandler.cpp
 *  metricspace
 *
 *  Created by Michael Tauraso on 12/17/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#if defined(_WIN32)
#	include <GL/glut.h>
#else
#	include <GLUT/glut.h>
#endif

#include "Mouse.h"
#include "Camera.h"


Mouse * Mouse::m_instance = 0;

Mouse * Mouse::getInstance()
{
	if(! m_instance)
	{
		m_instance = new Mouse();
	}
	
	return m_instance;
}

Mouse::Mouse()
:m_lmb(false),m_rmb(false),m_mmb(false),m_x(0),m_y(0),
 m_angleSpeed(1.0),m_panSpeed(0.1),m_zoomSpeed(0.1)
{
	GlutInit();
}


void Mouse::GlutInit()
{
	glutMotionFunc(MotionFunc);
	glutPassiveMotionFunc(PassiveMotionFunc);
	glutMouseFunc(MouseFunc);
}

void MotionFunc(int inx, int iny)
{
	Mouse * mouse = Mouse::getInstance();
	//keep tabs on the mouse
	int x = mouse->m_x-inx;
	int y = mouse->m_y -iny;
	mouse->m_x = inx;
	mouse->m_y = iny;
	
	
	Camera * camera = Camera::getInstance();
	
	if(mouse->m_lmb)
	// pan the look at point around
	// the math here is hard to deal with
    // and the motion originally intended
	// is awkward and undefined sometimes.
	{
	/*	Tuple pos = camera->getLookAt();
		
		Tuple ydir = camera->getUpVec();
		ydir -= ydir.dot(Tuple(0,0,1))*Tuple(0,0,1);
		ydir = ydir.normalize();
		
		Tuple xdir = Tuple(0,0,1).cross(ydir).normalize();
		
		pos += xdir * x * mouse->m_panSpeed;
		pos += ydir * y * mouse->m_panSpeed;
		

		camera->setLookAt(pos);*/
		
	}
	
	if(mouse->m_rmb)
	// we'll use this swipe to rotate about the
	// look at point
	{
		Tuple pos = camera->getSphereLocation();
		
		pos[1] += x * mouse->m_angleSpeed;
		pos[2] += y * mouse->m_angleSpeed;
		
		if(pos[1] <0)
		{
			pos[1] += 360;
		}
		else if(pos[1] > 360)
		{
			pos[1] -= 360;
		}
			
		if(pos[2] <= 0)
		{
			pos[2] = 1;
		}
		else if(pos[2] >= 180)
		{
			pos[2] = 179;
		}
		
		camera->setSphereLocation(pos);
	}
	
	if(mouse->m_mmb)
	//use the y coordinate to zoom in and out of look at point
	{
		Tuple pos = camera->getSphereLocation();
		
		pos[0] += y * mouse->m_zoomSpeed;
		
		if(pos[0] < 0)
		{
			//flip the view across the look at point
			//if we pass through the look at point
			pos[0] = -pos[0];
			pos[1] += 180;
			pos[2] += 2*(90-pos[2]);
		}
		
		camera->setSphereLocation(pos);
	}
}

void PassiveMotionFunc(int inx, int iny)
{
	Mouse * mouse = Mouse::getInstance();
	// this doesn't get called when a mouse button is
	// held down, so best to correct errors here
	// in case we don't keep track of the buttons right
	mouse->m_lmb = false;
	mouse->m_rmb = false;
	mouse->m_mmb = false;
	
	int x = mouse->m_x - inx;
	int y = mouse->m_y - iny;
	mouse->m_x = inx;
	mouse->m_y = iny;
}

void MouseFunc(int button, int state, int x, int y)
{
	Mouse * mouse = Mouse::getInstance();
	//keep current state for queries by the motion function
	bool * buttonPressed = 0;
	switch(button)
	{
		case GLUT_LEFT_BUTTON:
			buttonPressed = &mouse->m_lmb;
			break;
		case GLUT_RIGHT_BUTTON:
			buttonPressed = &mouse->m_rmb;
			break;
		case GLUT_MIDDLE_BUTTON:
			buttonPressed = &mouse->m_mmb;
			break;
	}
	if(buttonPressed)
	{
		switch(state)
		{
			case GLUT_UP:
				*buttonPressed = false;
				break;
			case GLUT_DOWN:
				*buttonPressed = true;
				break;
		}
	}
	
	// add something if we want to do anything 
	// with the mouse clicks other than keeping state
	// for the motion functions
	
}


void Mouse::setAngleSpeed(float speed)
{
	m_angleSpeed = speed;
}

float Mouse::getAngleSpeed()
{
	return m_angleSpeed;
}

void Mouse::setPanSpeed(float speed)
{
	m_panSpeed = speed;
}

float Mouse::getPanSpeed()
{
	return m_panSpeed;
}

void Mouse::setZoomSpeed(float speed)
{
	m_zoomSpeed = speed;
}

float Mouse::getZoomSpeed()
{
	return m_zoomSpeed;
}

