/*
 *  Shader.h
 *  metricspace
 *
 *  Created by Michael Tauraso on 12/19/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */


#include <glutwrapper.h>
#include<string>
#include<iostream>
#include<vector>

#pragma once


class Shader
{
public:
	Shader(std::string filename, GLenum shaderType);
	Shader(const Shader& shader);
	
	std::string getFilename();
	
	~Shader();
private:
	void Init(std::string filename, GLenum shaderType);
		
	void compile();
	
	void dump(std::ostream&);	
		
	std::string m_filename;
	//static std::vector<Shader*> * s_shaders;
	GLhandleARB m_shader;
	
	friend class ShaderProg;
};

class ShaderProg
{
public:
	ShaderProg();
	
	GLhandleARB getHandle();

	//the ShaderProg owns your shader now.
	void attach(Shader* shader);
	
	void detach(std::string filename);
	
	void dump(std::ostream &);
	
	void link();
	
	//void validate();
	
	void use();
	
	~ShaderProg();
private:
	std::vector<Shader *> m_shaders;
	GLhandleARB m_shader;
	
	static std::vector<ShaderProg*> * s_shaderProgs;
	static ShaderProg * s_shaderInUse;
};


