/*
 *  Tuple.h
 *  metricspace
 *
 *  Created by Michael Tauraso on 12/17/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */


#pragma once

class Matrix;

class RowTuple;

class Tuple
{
public:
	Tuple();
	Tuple(float x, float y, float z=0, float w=0);
	
	Tuple(const Tuple &);
	
	//Tuple operator = (const Tuple & rhs);
	
	Tuple& operator += (const Tuple & rhs);
	Tuple& operator -= (const Tuple & rhs);
	Tuple& operator *= (const float rhs);
	Tuple& operator /= (const float rhs);
	
	float& operator[](const int i);
	const float& operator[](const int i) const;
	
	//float [] getArray();
	
	Tuple  operator +(const Tuple & rhs) const;
	Tuple  operator -(const Tuple & rhs) const;

	Tuple operator *(const float rhs) const;
	Tuple operator /(const float rhs) const;
	
	//inner product
	float  dot(const Tuple& rhs) const;
	
	//outer product
	Matrix outer(const Tuple & rhs) const;
	
	Tuple  cross(const Tuple & rhs) const; 
	
	bool operator ==(const Tuple & rhs) const;
	
	Tuple normalize() const;
	
protected:
	float m_val[4];
	
};

class ColumnTuple: public Tuple
{
public:
	ColumnTuple(const Tuple &);
	
	RowTuple transpose() const;
	
	// this is an outer product
	Matrix operator * (const RowTuple & rhs) const;
};

class RowTuple: public Tuple
{
public:
	
	RowTuple(const Tuple &);
	
	ColumnTuple transpose() const;
	
	//this is an inner product
	float operator * (const ColumnTuple & rhs) const; 
};