/*
 *  main.cpp
 *  metricspace
 *
 *  Created by Michael Tauraso on 12/16/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */

#include <glew.h>
#if defined(_WIN32)
#	include <GL/glut.h>
#else
#	include <GLUT/glut.h>
#endif


#include "Camera.h"
#include "Mouse.h"
#include "Metric.h"



void renderScene();
void processNormalKeys(unsigned char key, int x, int y);
void processSpecialKeys(int key, int x, int y);
void mouseClick(int button, int state, int x, int y);
void setShaders();

void changeMetric(int metric);

int main(int argc, char **argv)
{
	
	glutInit(&argc,argv);
	
	glutInitWindowSize(400,400);
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
	glutCreateWindow("Metric Space");
	
	glutDisplayFunc(renderScene);
	glutIdleFunc(renderScene);
	
	glutKeyboardFunc(processNormalKeys);
	glutSpecialFunc(processSpecialKeys);	
	
	//make sure the camera gets initialized
	Camera::getInstance();
	//make sure the mouse gets initialized
	Mouse::getInstance();
	
	glEnable(GL_DEPTH_TEST);
	
	//glClearColor(1.0,1.0,1.0,1.0);
	
	glewInit();
	if (GLEW_ARB_vertex_shader && GLEW_ARB_fragment_shader)
		printf("Your graphics card is the shit\n");
	else {
		printf("you suck\n");
		exit(1);
	}
	
	/*if (glewIsSupported("GL_VERSION_2_0"))
		printf("Ready for OpenGL 2.0\n");
	else {
		printf("OpenGL 2.0 not supported\n");
		exit(1);
	}*/
	
	//setShaders();
	changeMetric(0);
	
	glutMainLoop();
	
}

/*char *textFileRead(char *fn) {
	
	
	FILE *fp;
	char *content = NULL;
	
	int count=0;
	
	if (fn != NULL) {
		fp = fopen(fn,"rt");
		
		if (fp != NULL) {
			
			fseek(fp, 0, SEEK_END);
			count = ftell(fp);
			rewind(fp);
			
			if (count > 0) {
				content = (char *)malloc(sizeof(char) * (count+1));
				count = fread(content,sizeof(char),count,fp);
				content[count] = '\0';
			}
			fclose(fp);
		}
	}
	return content;
}*/


//void setShaders(void)
//{
	//current = new EuclideanMetric();
	
	/*current = new RiemannianMetric(Matrix(Tuple(1,0,0),
										  Tuple(0,1,0),
										  Tuple(0,0,1)));*/
	
	//current->Apply();
	// old code ^^
	

	//GLhandleARB v,f,f2,p;
	//ShaderProg p;
	
	//char *vs = NULL,*fs = NULL,*fs2 = NULL;
	
	//v = glCreateShaderObjectARB(GL_VERTEX_SHADER_ARB);
	//f = glCreateShaderObjectARB(GL_FRAGMENT_SHADER_ARB);
	//f2 = glCreateShaderObjectARB(GL_FRAGMENT_SHADER_ARB);	
	
	//vs = textFileRead("toon.vert");
	//fs = textFileRead("toon.frag");
	//fs2 = textFileRead("toon2.frag");
	
	//const char * ff = fs;
	//const char * ff2 = fs2;
	//const char * vv = vs;
	
	//glShaderSourceARB(v, 1, &vv,NULL);
	//glShaderSourceARB(f, 1, &ff,NULL);
	//glShaderSourceARB(f2, 1, &ff2,NULL);
	
	//Shader * v= new Shader("toon.vert", GL_VERTEX_SHADER_ARB);
	//Shader * f= new Shader("toon.frag", GL_FRAGMENT_SHADER_ARB);
	//Shader * f2= new Shader("toon2.frag", GL_FRAGMENT_SHADER_ARB);
	
	//free(vs);free(fs);
	
	//glCompileShaderARB(v);
	//glCompileShaderARB(f);
	//glCompileShaderARB(f2);
	
	//p = glCreateProgramObjectARB();
	//glAttachObjectARB(p,f);
	//glAttachObjectARB(p,f2);
	//glAttachObjectARB(p,v);
	
	//p.attach(f);
	//p.attach(f2);
	//p.attach(v);
	
	//glLinkProgramARB(p);
	//glUseProgramObjectARB(p);
	
	//p.use();
//}

int prim = 0;
bool wire = true;

void drawPrimitive()
{
	switch(prim)
	{
	//sphere
	case 0:
		if(wire)
			glutWireSphere(1.0f, 50, 50);
		else
			glutSolidSphere(1.0f, 50, 50);
		break;
	case 2:
	case 1:
		if(wire)
			glutWireTeapot(1);
		else
			glutSolidTeapot(1);
		break;
	default:
		prim = 0;
		break;
	}
}

Metric * current = NULL;
void changeMetric(int metric)
{
	if(current)
		delete current;
	switch(metric)
	{
		default:
		case 0:
			current = new EuclideanMetric();
			break;
		case 1:
			current = new CityBlockMetric();
			break;
		case 2:
			current = new RiemannianMetric("riemann.mat");
			break;
	}
	
	current->Apply();
}


void renderScene(void) {
	/*glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	glPushMatrix();
	
	glutSolidTeapot(1);
	
	glPopMatrix();
	glutSwapBuffers();*/
	
	//float lpos[4] = {1,0.5,1,0};
	
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	//glPushMatrix();
	glLoadIdentity();
	Camera::getInstance()->Look();
	
	//glLightfv(GL_LIGHT0, GL_POSITION, lpos);
	//glutWireTeapot(1);
	//glutWireSphere(1.0f, 30, 40);
	drawPrimitive();
	//glPopMatrix();
	
	glutSwapBuffers();
}


//put this in a keyboard handler somewhere
void processSpecialKeys(int key, int x, int y) {
	
	/*switch(key) {
		case GLUT_KEY_UP :
			phi++;
			break;
		case GLUT_KEY_DOWN :
			phi--;
			break;
		case GLUT_KEY_LEFT : 
			theta++;
			break;
		case GLUT_KEY_RIGHT:
			theta--;
			break;
	}*/
}

//put this in a keyboard handler somewhere
void processNormalKeys(unsigned char key, int x, int y) 
{
	switch(key)
	{
		case 'q':
		case 27:
			exit(0);
		case '1':
		case '2':
		case '3':
			prim = key - '1';
			break;
		case 'f':
			wire = !wire;
			break;
		//Euclidean
		case 'e':
			changeMetric(0);
			break;
		//city block
		case 't':
			changeMetric(1);
			break;
		//Riemannian
		case 'r':
			changeMetric(2);
			break;
		//add wasd eventually
	}
	
}
